
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Widget_catalog_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const widget_catalog_items = await db.widget_catalog_items.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        icon_name: data.icon_name
        ||
        null
            ,
            
        author_name: data.author_name
        ||
        null
            ,
            
        widget_type: data.widget_type
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        is_public: data.is_public
        ||
        false
        
            ,
            
        is_adult_only: data.is_adult_only
        ||
        false
        
            ,
            
        schema_json: data.schema_json
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await widget_catalog_items.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.widget_catalog_items.getTableName(),
                belongsToColumn: 'bundle_files',
                belongsToId: widget_catalog_items.id,
            },
            data.bundle_files,
            options,
        );
        

        return widget_catalog_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const widget_catalog_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                icon_name: item.icon_name
            ||
            null
            ,
            
                author_name: item.author_name
            ||
            null
            ,
            
                widget_type: item.widget_type
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                is_public: item.is_public
            ||
            false
        
            ,
            
                is_adult_only: item.is_adult_only
            ||
            false
        
            ,
            
                schema_json: item.schema_json
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const widget_catalog_items = await db.widget_catalog_items.bulkCreate(widget_catalog_itemsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < widget_catalog_items.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.widget_catalog_items.getTableName(),
                    belongsToColumn: 'bundle_files',
                    belongsToId: widget_catalog_items[i].id,
                },
                data[i].bundle_files,
                options,
            );
        }
        

        return widget_catalog_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const widget_catalog_items = await db.widget_catalog_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.icon_name !== undefined) updatePayload.icon_name = data.icon_name;
        
        
        if (data.author_name !== undefined) updatePayload.author_name = data.author_name;
        
        
        if (data.widget_type !== undefined) updatePayload.widget_type = data.widget_type;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.is_public !== undefined) updatePayload.is_public = data.is_public;
        
        
        if (data.is_adult_only !== undefined) updatePayload.is_adult_only = data.is_adult_only;
        
        
        if (data.schema_json !== undefined) updatePayload.schema_json = data.schema_json;
        
        
        updatePayload.updatedById = currentUser.id;

        await widget_catalog_items.update(updatePayload, {transaction});

        
        
        if (data.organizations !== undefined) {
            await widget_catalog_items.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.widget_catalog_items.getTableName(),
                belongsToColumn: 'bundle_files',
                belongsToId: widget_catalog_items.id,
            },
            data.bundle_files,
            options,
        );
        

        return widget_catalog_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const widget_catalog_items = await db.widget_catalog_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of widget_catalog_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of widget_catalog_items) {
                await record.destroy({transaction});
            }
        });


        return widget_catalog_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const widget_catalog_items = await db.widget_catalog_items.findByPk(id, options);

        await widget_catalog_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await widget_catalog_items.destroy({
            transaction
        });

        return widget_catalog_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const widget_catalog_items = await db.widget_catalog_items.findOne(
            { where },
            { transaction },
        );

        if (!widget_catalog_items) {
            return widget_catalog_items;
        }

        const output = widget_catalog_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.overlay_widgets_catalog_item = await widget_catalog_items.getOverlay_widgets_catalog_item({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.bundle_files = await widget_catalog_items.getBundle_files({
            transaction
        });
        
        
        output.organizations = await widget_catalog_items.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'bundle_files',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'widget_catalog_items',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.icon_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'widget_catalog_items',
                        'icon_name',
                        filter.icon_name,
                    ),
                };
            }
            
            if (filter.author_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'widget_catalog_items',
                        'author_name',
                        filter.author_name,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'widget_catalog_items',
                        'description',
                        filter.description,
                    ),
                };
            }
            
            if (filter.schema_json) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'widget_catalog_items',
                        'schema_json',
                        filter.schema_json,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.widget_type) {
                where = {
                    ...where,
                widget_type: filter.widget_type,
            };
            }
            
            if (filter.is_public) {
                where = {
                    ...where,
                is_public: filter.is_public,
            };
            }
            
            if (filter.is_adult_only) {
                where = {
                    ...where,
                is_adult_only: filter.is_adult_only,
            };
            }
            


      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.widget_catalog_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'widget_catalog_items',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.widget_catalog_items.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

